{-----------------------------------------------------------------------------}
{   Code source  utilis dans la leon 3 du Guide Pratique de
{   la programmation de directshow sous delphi publi par Paul Glagla
{   sur le site http://paul.glagla.free.fr
{
{-----------------------------------------------------------------------------}
unit Unit1;

{-----------------------------------------------------------------------------}
interface

{-----------------------------------------------------------------------------}
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DSPack, StdCtrls, Buttons, Menus, ComCtrls;

{-----------------------------------------------------------------------------}
type
  TForm1 = class(TForm)
    PlayBtn: TBitBtn;
    StopBtn: TBitBtn;
    PauseBtn: TBitBtn;
    FilterGraph1: TFilterGraph;
    QuitterBtn: TBitBtn;
    VideoWindow1: TVideoWindow;
    PleinEcranBtn: TBitBtn;
    PopupMenu1: TPopupMenu;
    Play1: TMenuItem;
    Pause1: TMenuItem;
    Stop1: TMenuItem;
    PleinEcran1: TMenuItem;
    Quitter1: TMenuItem;
    DSTrackBar1: TDSTrackBar;
    OpenDialog1: TOpenDialog;
    OuvrirBtn: TBitBtn;
    procedure PlayBtnClick(Sender: TObject);
    procedure QuitterBtnClick(Sender: TObject);
    procedure PauseBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure PleinEcranBtnClick(Sender: TObject);
    procedure Play1Click(Sender: TObject);
    procedure Pause1Click(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
    procedure PleinEcran1Click(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure OuvrirBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

{-----------------------------------------------------------------------------}
var
  Fichier:string;
  Form1: TForm1;
{-----------------------------------------------------------------------------}
implementation

{$R *.dfm}

{-----------------------------------------------------------------------------}
procedure TForm1.PlayBtnClick(Sender: TObject);
begin
if not filtergraph1.active then begin
  filtergraph1.active:=true;
  filtergraph1.RenderFile(fichier);
end;
filtergraph1.Play;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.QuitterBtnClick(Sender: TObject);
begin
close;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.PauseBtnClick(Sender: TObject);
begin
filtergraph1.Pause;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.StopBtnClick(Sender: TObject);
begin
filtergraph1.Stop;
filtergraph1.Active:=false;;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
filtergraph1.cleargraph;
filtergraph1.active:=false;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.PleinEcranBtnClick(Sender: TObject);
begin
videowindow1.FullScreen:=true;
pleinEcran1.Checked:=videoWindow1.fullscreen;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.Play1Click(Sender: TObject);
begin
playBtnClick(sender);
end;

{-----------------------------------------------------------------------------}
procedure TForm1.Pause1Click(Sender: TObject);
begin
PauseBtnClick(Sender);
end;

{-----------------------------------------------------------------------------}
procedure TForm1.Stop1Click(Sender: TObject);
begin
StopBtnClick(Sender);
end;

{-----------------------------------------------------------------------------}
procedure TForm1.PleinEcran1Click(Sender: TObject);
begin
videoWindow1.FullScreen:=not videowindow1.FullScreen;
pleinEcran1.Checked:=videoWindow1.fullscreen;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.Quitter1Click(Sender: TObject);
begin
quitterBtnClick(Sender);
end;

{-----------------------------------------------------------------------------}
procedure TForm1.OuvrirBtnClick(Sender: TObject);
begin
// Attention: prvoir une gestion des erreurs
if opendialog1.execute then begin
stopBtnclick(sender);
fichier:=opendialog1.filename;
playBtnClick(sender);
end;//if opendialog1
end;
{-----------------------------------------------------------------------------}
end.
